# SPDX-License-Identifier: (GPL-2.0 OR BSD-2-Clause)
%YAML 1.2
---
$id: http://devicetree.org/schemas/regulator/qcom,wcn3990-pmu.yaml#
$schema: http://devicetree.org/meta-schemas/core.yaml#

title: Qualcomm Technologies, Inc. WCN3990 PMU Regulators

maintainers:
  - Bartosz Golaszewski <bartosz.golaszewski@oss.qualcomm.com>

description:
  The WCN3990 package contains discrete modules for WLAN and Bluetooth. They
  are powered by the Power Management Unit (PMU) that takes inputs from the
  host and provides LDO outputs. This document describes this module.

properties:
  compatible:
    enum:
      - qcom,wcn3950-pmu
      - qcom,wcn3988-pmu
      - qcom,wcn3990-pmu
      - qcom,wcn3991-pmu
      - qcom,wcn3998-pmu

  vddio-supply:
    description: VDD_IO supply regulator handle

  vddxo-supply:
    description: VDD_XTAL supply regulator handle

  vddrf-supply:
    description: VDD_RF supply regulator handle

  vddch0-supply:
    description: chain 0 supply regulator handle

  vddch1-supply:
    description: chain 1 supply regulator handle

  swctrl-gpios:
    maxItems: 1
    description: GPIO line indicating the state of the clock supply to the BT module

  clocks:
    maxItems: 1
    description: Reference clock handle

  regulators:
    type: object
    description:
      LDO outputs of the PMU

    patternProperties:
      "^ldo[0-9]$":
        $ref: regulator.yaml#
        type: object
        unevaluatedProperties: false

    additionalProperties: false

required:
  - compatible
  - regulators
  - vddio-supply
  - vddxo-supply
  - vddrf-supply
  - vddch0-supply

additionalProperties: false

examples:
  - |
    #include <dt-bindings/gpio/gpio.h>
    pmu {
        compatible = "qcom,wcn3990-pmu";

        vddio-supply = <&vreg_io>;
        vddxo-supply = <&vreg_xo>;
        vddrf-supply = <&vreg_rf>;
        vddch0-supply = <&vreg_ch0>;

        regulators {
            vreg_pmu_io: ldo0 {
                regulator-name = "vreg_pmu_io";
            };

            vreg_pmu_xo: ldo1 {
                regulator-name = "vreg_pmu_xo";
            };

            vreg_pmu_rf: ldo2 {
                regulator-name = "vreg_pmu_rf";
            };

            vreg_pmu_ch0: ldo3 {
                regulator-name = "vreg_pmu_ch0";
            };
        };
    };
